function [vXr, vYr] = reflect(vX0, vY0, a, n, offsetX, offsetY)
vX0 = vX0(:).';
vY0 = vY0(:).';
vX0 = vX0 - offsetX;
vY0 = vY0 - offsetY;
N = length(vX0);
if a == pi/3 %fini
        vR = vX0 + j*vY0;
        vXr = real(abs(vR).*exp(j*(a + angle(vR))));
        vYr = imag(abs(vR).*exp(j*(a + angle(vR))));
       vXr = vXr + offsetX;
       vYr = vYr + offsetY;
       return
end
a = a*n;
vComp = reshape([vX0; vY0], 2*N, 1);
M = [cos(2*a) sin(2*a); sin(2*a) -cos(2*a)];
c = num2cell(ones(1,N));
[c{:}] = deal(M);
mM = blkdiagf(c{:});
vNew_comp = mM*vComp;
x_ind = 1:2:2*N;
y_ind = x_ind+1;
vXr = vNew_comp(x_ind) + offsetX;
vYr = vNew_comp(y_ind) + offsetY;