function err = bc_error(mZ, mBNegate, vSolution, varargin)
if ~isempty(varargin)
        G = varargin{1};
        bPlot = 1;
else
        bPlot = 0;
end

vSolution = vSolution(:);
abs_err = mZ*vSolution;
% calculate average on the interface
L = length(vSolution);
mZ(mBNegate) = -mZ(mBNegate);
vAvg = mZ*vSolution;
M = rms(vAvg);
%M = max(abs(mZ*vAvg));
err = rms(abs_err)/M;
if bPlot
        hold off
        plot(abs(abs_err),'r')
        hold on
        plot(abs(vAvg),'g')
        hold off
end