function [vBeta, vErr_at_peaks] = find_modes(oGeom, k0, min_beta, max_beta, tol, sm, bPlot)
vBeta = [min_beta, max_beta];
[vBeta, vErr] = dispatch(vBeta, bPlot, oGeom, k0, sm, tol);
[dummy, mj] = local_maxima(1./vErr);
if isempty(mj)
    vBeta = [];
    vErr_at_peaks = [];
    return
end
vBeta = vBeta(mj);
vErr_at_peaks = vErr(mj);
