% Find local maxima in matrix m, edges are excluded
% [mi, mj] = local_maxima(m)
function [mi, mj] = local_maxima(m)
[r,c] = size(m);
mi = [];
mj = [];
ind_m=1;
if (r==1) || (c==1)
    m = m(:);
    L =length(m);
    for ind = 2:L-1
        u = m(ind);
        neigh = [m(ind-1) m(ind+1)];
        if sum(u > neigh) == 2
            mi(ind_m) = ind;
            mj(ind_m) = ind;
            ind_m = ind_m +1;
        end
    end
    return
end
ind = 1;
for indi = 2:r-1
    for indj = 2:c-1
        u = m(indi, indj);
        neigh = [m(indi-1, indj-1) m(indi+1, indj+1) m(indi-1, indj+1) m(indi+1, indj-1) ...
                m(indi, indj-1) m(indi, indj+1) m(indi-1, indj) m(indi+1, indj)];
        if sum(u >= neigh) == 8
            mi(ind) = indi;
            mj(ind) = indj;
            ind = ind +1;
        end
    end
end
